<template>
    <p v-if="currentSettings.videoUrl.length === 0">
      {{ t("Please enter a video URL in settings") }}
    </p>
    <iframe
      v-else-if="isYT"
      id="video__yt-player"
      width="100%"
      height="100%"
      :src="embedUrl(currentSettings.videoUrl)"
    ></iframe>
    <video
      v-else
      :src="currentSettings.videoUrl"
      autoplay
      :loop="currentSettings.loop"
      width="100%"
      height="100%"
    >
      Invalid URL
    </video>
</template>

<script>
module.exports = {
  name: "video_player",
  props: {
    currentSettings: {
      type: Object,
      required: true,
    },
    currentStyles: {
      type: Object,
      required: true
    },
    currentDimensions: {
      type: Object,
      required: true
    },
    records: {
      type: Array,
      required: false
    },
    language: {
      type: String,
      required: true
    },
    locale: {
      type: String,
      required: true
    },
    backendUrl: {
      type: String,
      required: true
    },
    fetchAsset: {
      type: Function,
      required: false
    }
  },
  computed: {
    isYT: function() {
      return this.currentSettings.videoUrl.match(/youtube.com|youtu.be/) != null;
    }
  },
  methods: {
    embedUrl: function(ytUrl) {
      const EMBED_URL = ytUrl
        .replace(/youtu\.be/, "www.youtube.com/embed")
        .replace(/watch\?v=/, "embed/");
      const VIDEO_ID = new URL(EMBED_URL).pathname.split("/").pop();
      const LOOPING = this.currentSettings.loop ? 1 : 0;
      const BASE = `${EMBED_URL}?autoplay=1&loop=${LOOPING}&controls=0&modestbranding=1&showinfo=0&iv_load_policy=3&fs=0&rel=0`;
      // AS3 and iFrame YouTube players require the video ID passed as playlist to support looping, see https://developers.google.com/youtube/player_parameters?hl=de#loop
      return this.currentSettings.loop ? `${BASE}&playlist=${VIDEO_ID}` : BASE;
    }
  },
  locales: {
    deDe: {
      "Please enter a video URL in settings":
        "Bitte gib in den Einstellungen eine Video-URL ein"
    },
    frFr: {
      "Please enter a video URL in settings":
        "S'il vous plaît entrer une URL de la vidéo dans les paramètres"
    },
    esEs: {
      "Please enter a video URL in settings":
        "Por favor, introduzca una URL de video en la configuración"
    },
    plPl: {
      "Please enter a video URL in settings":
        "Wprowadź adres URL filmu w ustawieniach"
    },
    koKr: {
      "Please enter a video URL in settings":
        "설정에서 동영상 URL을 입력하십시오."
    }
  }
};
</script>
<style>
#video__yt-player {
  border: 0;
}
</style>
